<template>
  <div class="container-main" ref="main">
    <div class="search-hearder" ref="topSearch">
      <el-form
        :model="queryParams"
        ref="queryForm"
        :inline="true"
        v-show="showSearch"
        label-width="auto"
      >
        <el-form-item label="材料名称" prop="materialsName">
          <el-input
            v-model="queryParams.materialsName"
            placeholder="请输入材料名称"
            clearable
            size="small"
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>
        <el-form-item label="发布时间" prop="fabuTime">
          <el-date-picker
            clearable
            size="small"
            v-model="queryParams.fabuTime"
            type="date"
            value-format="yyyy-MM-dd"
            placeholder="选择发布时间"
          >
          </el-date-picker>
        </el-form-item>
        <el-form-item>
          <el-button
            type="primary"
            icon="el-icon-search"
            size="mini"
            @click="handleQuery"
            >搜索</el-button
          >
          <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
            >重置</el-button
          >
        </el-form-item>
      </el-form>
    </div>
    <div class="layui-table-tool" ref="tableTool">
      <el-button
        type="primary"
        size="mini"
        @click="handleAdd()"
        v-hasPermi="['zongzhi:dongtai:add']"
        >新增</el-button
      >
      <el-button
        type="success"
        size="mini"
        :disabled="single"
        @click="handleUpdate"
        v-hasPermi="['zongzhi:dongtai:edit']"
        >修改</el-button
      >
      <el-button
        type="danger"
        size="mini"
        :disabled="multiple"
        @click="handleDelete"
        v-hasPermi="['zongzhi:dongtai:remove']"
        >删除</el-button
      >
      <el-button
        type="warning"
        size="mini"
        :loading="exportLoading"
        @click="handleExport"
        v-hasPermi="['zongzhi:dongtai:export']"
        >导出</el-button
      >
    </div>
    <el-table
      v-loading="loading"
      :data="dongtaiList"
      :height="tableHeigth"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="区域" align="center" prop="areaId">
        <template slot-scope="scope">
          <span>{{ scope.row.areaId | filterTown }}</span>
        </template>
      </el-table-column>
      <el-table-column label="类型" align="center" prop="type" />
      <el-table-column label="材料名称" align="center" prop="materialsName" />
      <el-table-column
        label="发布时间"
        align="center"
        prop="fabuTime"
        width="180"
      >
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.fabuTime, "{y}-{m}-{d}") }}</span>
        </template>
      </el-table-column>
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
        width="200"
        fixed="right"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            @click="handleInfo(scope.row)"
            v-hasPermi="['zongzhi:dongtai:list']"
          >
            查看
          </el-button>
          <el-button
            type="success"
            size="mini"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['zongzhi:dongtai:edit']"
            >修改</el-button
          >
          <el-button
            size="mini"
            type="danger"
            @click="handleDelete(scope.row)"
            v-hasPermi="['zongzhi:dongtai:remove']"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改工作动态对话框 -->
    <el-dialog
      :visible.sync="open"
      width="1000px"
      append-to-body
      custom-class="dialog-box"
    >
      <div slot="title" class="dialog-title">{{ title }}</div>
      <el-form
        ref="form"
        :model="form"
        :rules="rules"
        label-width="auto"
        class="dialog-from"
      >
        <el-row>
          <el-col :span="12">
            <el-form-item label="区域" prop="areaId">
              <el-cascader
                v-model="form.areaId"
                :options="townList"
                :props="treeProps"
                clearable
              ></el-cascader>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="类型" prop="type">
              <el-input v-model="form.type" placeholder="请输入类型" />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="12">
            <el-form-item label="材料名称" prop="materialsName">
              <el-input
                v-model="form.materialsName"
                placeholder="请输入材料名称"
              />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="发布时间" prop="fabuTime">
              <el-date-picker
                clearable
                size="small"
                v-model="form.fabuTime"
                type="date"
                value-format="yyyy-MM-dd"
                placeholder="选择发布时间"
              >
              </el-date-picker>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="12">
            <el-form-item label="动态名称" prop="name">
              <el-input v-model="form.name" placeholder="请输入动态名称" />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="12">
            <el-form-item label="材料文件" prop="materialsFileUrl">
              <FileUpload v-model="fileList" />
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <!--查看工作动态详情页-->
    <el-dialog
      :visible.sync="infoOpen"
      width="1000px"
      append-to-body
      :close-on-click-modal="false"
      :destroy-on-close="true"
      custom-class="dialog-box"
    >
      <div slot="title" class="dialog-title">{{ infoTitle }}</div>

      <el-descriptions
        title="工作动态"
        :column="2"
        border
        labelClassName="desLable"
      >
        <el-descriptions-item label="区域">{{
          form.areaId
        }}</el-descriptions-item>

        <el-descriptions-item label="类型">{{
          form.type
        }}</el-descriptions-item>

        <el-descriptions-item label="材料名称">{{
          form.materialsName
        }}</el-descriptions-item>

        <el-descriptions-item label="发布时间">{{
          form.fabuTime
        }}</el-descriptions-item>

        <el-descriptions-item label="动态名称">{{
          form.name
        }}</el-descriptions-item>
      </el-descriptions>
      <FileView :fileList="fileList" />
    </el-dialog>
  </div>
</template>

<script>
import { mapGetters } from "vuex";
import {
  listDongtai,
  getDongtai,
  delDongtai,
  addDongtai,
  updateDongtai,
  exportDongtai,
} from "@/api/zongzhi/netManage/workDynamic/index.js";
export default {
  computed: {
    ...mapGetters(["townList", "treeProps"]),
  },
  name: "Dongtai",
  //注释字典
  data() {
    return {
      fileList: [],
      tableHeigth: 0,
      //查看详情
      infoOpen: false,
      //详情标题
      infoTitle: "",
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 工作动态表格数据
      dongtaiList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        materialsName: null,

        fabuTime: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
    };
  },
  created() {
    // //给表格一个固定值
    this.$nextTick(() => {
      this.tableHeigth =
        this.$refs.main.offsetHeight -
        (this.$refs.topSearch.offsetHeight +
          this.$refs.tableTool.offsetHeight) -
        46;
      this.getList();
    });
  },
  filters: {
    filterTown(target) {
      if (target) {
        target = JSON.parse(target);
        if (target.length > 0 && Array.isArray(target)) {
          return target.join("、");
        } else {
          return "";
        }
      }
    },
  },
  methods: {
    /** 查询工作动态列表 */
    getList() {
      this.loading = true;
      listDongtai(this.queryParams).then((response) => {
        this.dongtaiList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,

        areaId: null,

        type: null,

        materialsName: null,

        fabuTime: null,

        materialsFileName: null,

        materialsFileUrl: null,

        createId: null,

        createBy: null,

        createTime: null,

        updateId: null,

        updateBy: null,

        updateTime: null,

        remark: null,

        name: null,
      };
      this.fileList = [];
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /**查看按钮操作 */
    handleInfo(row) {
      this.reset();
      const id = row.id || this.ids;
      getDongtai(id).then((response) => {
        response.data.areaId = JSON.parse(response.data.areaId);
        if (
          response.data.areaId.length > 0 &&
          Array.isArray(response.data.areaId)
        ) {
          response.data.areaId = response.data.areaId.join("、");
        } else {
          response.data.areaId = "";
        }
        this.filterFile(
          2,
          response.data.materialsFileName,
          response.data.materialsFileUrl
        );

        this.form = response.data;
        this.infoOpen = true;
        this.infoTitle = "查看工作动态详情";
      });
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加工作动态";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getDongtai(id).then((response) => {
        response.data.areaId = JSON.parse(response.data.areaId);

        this.filterFile(
          2,
          response.data.materialsFileName,
          response.data.materialsFileUrl
        );

        this.form = response.data;
        this.open = true;
        this.title = "修改工作动态";
      });
    },
    filterFile(state, fileName, fileUrl) {
      //1.提交 else 查看
      if (state == 1) {
        let fileName = [];
        let fileUrl = [];
        if (this.fileList.length > 0) {
          this.fileList.forEach((item) => {
            fileName.push(item.name);
            fileUrl.push(item.url);
          });
          this.form.materialsFileName = fileName.join(",");
          this.form.materialsFileUrl = fileUrl.join(",");
        } else {
          this.form.materialsFileName = "";
          this.form.materialsFileUrl = "";
        }
      } else {
        if (fileName || fileUrl) {
          fileName = fileName.split(",");
          fileUrl = fileUrl.split(",");
          fileName.forEach((item, index) => {
            this.fileList.push({
              name: item,
              url: fileUrl[index],
            });
          });
        } else {
          this.fileList = [];
        }
      }
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          this.form.areaId = JSON.stringify(this.form.areaId);

          this.filterFile(1);
          if (this.form.id != null) {
            updateDongtai(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addDongtai(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm(
        '是否确认删除工作动态编号为"' + ids + '"的数据项?',
        "警告",
        {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        }
      )
        .then(function () {
          return delDongtai(ids);
        })
        .then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm("是否确认导出所有工作动态数据项?", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          this.download(
            "/zongzhi/dongtai/export",
            {
              ...this.queryParams,
            },
            "工作动态_" + new Date().getTime() + ".xlsx"
          );
          this.exportLoading = false;
        })
        .catch(() => {});
    },
  },
};
</script>
